
; pro eis_status_reformatter::initialise
;   self->trace, 'eis_status_reformatter::initialise'
;   self.packet_source_directory = getenv('HOME') + '/work/localdata/sdtp/merge/split'
; end

function eis_mission_data_reformatter::init
	print, 'eis_mission_data_reformatter::init'
	self.packet_list_directory = getenv('HOME') + '/work/localdata/sdtp/merge/split'
	return, 1
end

pro eis_mission_data_reformatter::debug
	self->trace, 'eis_mission_data_reformatter::debug'

	self->log, 'start_date                 : ' + self.start_date
	self->log, 'end_date                   : ' + self.end_date
	self->log, 'apid                       : ' + strtrim(string(self.apid), 2) ; format as hex
	self->log, 'packet_source_directory    : ' + self.packet_source_directory
	self->log, 'packet_list_directory      : ' + self.packet_list_directory
	self->log, 'source_filename            : ' + self.source_filename
	self->log, 'fits_filename              : ' + self.fits_filename


end

pro eis_mission_data_reformatter__define

  struct = { eis_mission_data_reformatter, $

             main_logger                : ptr_new(obj_new()), $
             logger                     : ptr_new(obj_new()), $

             ccsds_reader               : ptr_new(),          $
             
             eis_data                   : ptr_new(obj_new()), $
;             eis_cal                    : ptr_new(obj_new()), $ ; in eis_data
             plan                       : ptr_new(obj_new()), $
             spcd                       : ptr_new(obj_new()), $
             
             start_date                 : '',        $
             end_date                   : '',        $
             
             packet_source_directory    : '',        $
             packet_list_directory      : '',        $
             source_filename            : '',        $
             fits_filename              : '',        $

             level                      : '',        $
             
             grt                        : 0L,        $
             sc_start                   : 0L,        $
             sc_end                     : 0L,        $
             ut_start                   : '',        $
             ut_end                     : '',        $
             ut_start_write             : '',        $
             
             fits_base                  : '',        $
             fits_file                  : '',        $
             ti_conv                    : 0,         $
             fits_lun                   : 0,         $
           }
  
end
