;+
; NAME: eis_mission_data_reformatter__reformat.pro
;
; PURPOSE: Calls eis_mkfits to format the data into FITS files.
;
; CATEGORY: Science
;
; CALLING SEQUENCE: None
;
; INPUTS: None
;
; KEYWORD PARAMETERS: rescued
;
; OUTPUTS: None
;
; CALLS: eis_mkfits, make_md_fits
;
; COMMON BLOCKS: None.
;
; PROCEDURE:
;
; RESTRICTIONS: Uses SolarSoft
;
; MODIFICATION HISTORY:
;	  25/11/18 mcrw	wrote
;
;-

pro eis_mission_data_reformatter::reformat, dir, rescued=rescued
  self->trace, 'eis_mission_data_reformatter::reformat'

  files = file_search(filepath('eis_md*', root=dir), count=count)
  if count eq 0 then begin
     print, 'No files to reformat'
     return
  endif
  
  for i = 0, count - 1 do begin

     raster = obj_new('eis_md_raster', rescued=rescued)
     raster.read, files[i], rescued=rescued

     fits_maker = obj_new('eis_md_fits_maker')
     fits_maker.make_fits(raster)
     
     raster.make_fits
     raster.write_fits

     obj_destroy, raster
     obj_destroy, fits_maker
     
;;; Create an 'eis_data' object, read in the ccsds data packets
     ;;; and fill out the header struct (hdr)
     data = obj_new('eis_data', files[i], datasource='ccsds', hdr=hdr)
;     exp_info = (hdr[0])->getexp_info()
;     seq_id = exp_info.seq_id
;     rast_id = exp_info.rast_id
;;;     plan = obj_new('eis_plan')
     if keyword_set(rescued) then begin
        self->log, 'eis_mkfits, data, hdr, /doplan, /dospcd, fitsdir=self.fits_dir, outfile=self.fits_reformat_log, /rescued'
;;;        self->eis_mkfits, data, hdr, /doplan, /dospcd, fitsdir=self.fits_dir, outfile=self.fits_reformat_log, /rescued
;;;        self->eis_mkfits, data, hdr, /doplan, /dospcd, /rescued
     end else begin
        self->log, 'eis_mkfits, data, hdr, /doplan, /dospcd, fitsdir=self.fits_dir, outfile=self.fits_reformat_log'
;;;        self->eis_mkfits, data, hdr, /doplan, /dospcd, fitsdir=self.fits_dir, outfile=self.fits_reformat_log
;;;        self->eis_mkfits, data, hdr, /doplan, /dospcd
     endelse
;;;;;     data->mkfits, hdr, /doplan, /dospcd, rescued=rescued
     self->eis_mkfits, data, hdr, /doplan, /dospcd, rescued=rescued
     self->log, 'Completed ' + files[i]
;     obj_destroy, plan          ; or move out of loop?
     obj_destroy, data
  endfor

end


