;+
; NAME:
;       EISTIM2UTC
;
; PURPOSE:
;  Converts time from format used for filenames to format used internally in fits
;  files. This function is made as ssw's anytim2utc(time,/ccsds) seems to have a 
;  bug when called "in the midnight hour" (this means during hour 00 for the less 
;  poetic amongst you).
;
; CATEGORY:
;       Data Processing Software
;
; CALLING SEQUENCE:
;       utc=eistim2utc(eis_tim)
;
; INPUTS:
;       eis_tim: yyyymmdd_hrmnsc
;
; KEYWORD PARAMETERS:
;       none
;
; OUTPUTS:
;       yyyy-mm-ddThr:mn:sc.dhm
;
; CALLS:
;
; COMMON BLOCKS:
;
; PROCEDURE:
;
; RESTRICTIONS:
;
;
; MODIFICATION HISTORY:
;       08 Dec 2006  : Viggo Hansteen/Matthew Whillock 
;
;-
function eistim2utc,eis_tim

return,strmid(eis_tim,0,4)+ $
   '-'+strmid(eis_tim,4,2)+ $
   '-'+strmid(eis_tim,6,2)+ $
   'T'+$
       strmid(eis_tim,9,2)+':'+$
       strmid(eis_tim,11,2)+':'+$
       strmid(eis_tim,13,2)+'.000'
end


