;+
; NAME:
;       EIS_AUX__DEFINE
;
; PURPOSE:
;       Defines the class EIS_AUX, the class for auxiliary
;       objects for EIS data. The EIS_AUX class inherits the HW_AUX
;       superclass. For a complete description of the contents of the
;       instance data of the AUX objects, see HW_AUX__DEFINE. The
;       EIS_AUX class has no self defined parameters other than the
;       ones inhereted from HW_AUX. All methods are also inhereted,
;       except the init-method, that fill the instance data with the
;       EIS specific contents.
;
; CATEGORY:
;       Hansteen/Wikstol Data analysis SW
;
; CALLING SEQUENCE:
;         eis_aux = obj_new('eis_aux'). The init method is
;         automatically run when the object is declared, and all the
;         objects parameters are set there.
;
; INPUTS:
;       None
;
; KEYWORD PARAMETERS:
;
; OUTPUTS:
;       See HW_AUX__DEFINE for a description of the object's instance
;       data.
;
; CALLS:
;
; COMMON BLOCKS:
;
; PROCEDURE:
;       Defines the EIS_AUX object and fille the parameters (instance
;       data) of the object in the init-method.
;
; RESTRICTIONS:
;
; MODIFICATION HISTORY:
;       XX-Aug-2001: Viggo Hansteen
;       01-Oct-2001: Oivind Wikstol - Added documentation.
;       02-Sep-2002: Oivind Wikstol - Modified structure of menu system
;       20-Apr-2004: Oivind Wikstol - Added funtions to change wavl. 
;                                     scale [pix/Angstr.]
;       17-Nov-2006: Viggo Hansteen - Added filename parameter to init method.
;       10-Feb-2007: Viggo Hansteen - Added help mehtods.
;       17-Jan-2008: A. Gardini     - Added the moments' units.
;        4-Jul-2008: A. Gardini     - Added HELP and INIT_AUX_METHODS.
;       23-Sep-2008: A. Gardini     - Added error variable names and units.
;
; $Id: eis_aux__define.pro 405 2010-07-04 11:21:38Z viggoh $
;-

pro eis_aux__define
  nitem=10
  struct={eis_aux, $
          nparams:0, $
          wscale:'',$
          params:strarr(nitem), $
          filename:' ',$
          units:strarr(nitem), $
          inherits hw_aux}
end
