;+
; NAME:
;       FITS_HDR__DISPLAY
;
; PURPOSE:
;       FITS_HDR__DISPLAY is a method of the class EIS_HDR. It is used
;       to display the contents of a fits_hdr object as text.
;
; CATEGORY:
;       Hansteen/Wikstol Data analysis SW
;
; CALLING SEQUENCE:
;       fits_hdr-> display, textdump. fits_hdr is an object of class
;       FITS_HDR, textdump is the output.
;
; INPUTS:
;
;
; KEYWORD PARAMETERS:
;
; OUTPUTS:
;       Textdump: A string containing the values of all the parameters
;       of the header object and a description of it.
;
; CALLS:
;
; COMMON BLOCKS:
;
;
; PROCEDURE:
;       FITS_HDR__DISPLAY reads all the instance data of an FITS_HDR
;       object, and stores it as strings in a string array together
;       with a description of the data. All strings are then finallly
;       joined in one long string (textdump) with CR at the rigth
;       places. The variable 'textdump is the output from the method,
;       and the header can then be displayed as text by printing
;       'textdump'.
;
; RESTRICTIONS:
;
;
; MODIFICATION HISTORY:
;       14-Oct-2004: Oivind Wikstol.
;        4-Jul-2008: A. Gardini.     - Added the init keyword.
;-
pro fits_hdr::display,textdump,init=init
  if n_elements(init) eq 1 then return
  textdump=self-> getbte_hdr()
end
