pro eis_spcd::construct,parameter,init=init
  if n_elements(init) eq 1 then return
  parameter=strupcase(parameter)
;  construct array of times and parameter(time) from date_obs to date end
;  find out which type of file the parameter is in
  case parameter of
  'TIME_AOCS1': begin
     filehead = 'eis_aocs1'
     bintable = 2
     read_all_files = 1
     parameter='TIME'
             end
  'TIME_HK2': begin
     filehead = 'eis_hk2'
     bintable = 2
     read_all_files = 1
     parameter='TIME'
             end
  'TIME_STS1': begin
     filehead = 'eis_sts1'
     bintable = 12
     read_all_files = 1
     parameter='TIME'
             end
  'TIME_STS3': begin
     filehead = 'eis_sts3'
     bintable = 11
     read_all_files = 1
     parameter='TIME'
             end
  'TIME_SOT': begin
     filehead = 'eis_sot'
     bintable = 2
     read_all_files = 1
     parameter='TIME'
             end
  'SAT_ROT': begin
     filehead = 'eis_aocs1'
     bintable = 1
     read_all_files = 1
             end
  'UFSAXANG': begin
     filehead = 'eis_aocs1'
     bintable = 1
     read_all_files = 1
             end
  'UFSAYANG': begin
     filehead = 'eis_aocs1'
     bintable = 1
     read_all_files = 1
             end
  'UFSBXANG': begin
     filehead = 'eis_aocs1'
     bintable = 1
     read_all_files = 1
             end
  'UFSBYANG': begin
     filehead = 'eis_aocs1'
     bintable = 1
     read_all_files = 1
             end
  'ERRANGZ': begin
     filehead = 'eis_aocs1'
     bintable = 1
     read_all_files = 1
             end
  'SC_ATT_X': begin
     filehead = 'eis_hk2'
     bintable = 1
     read_all_files = 1
             end
  'SC_ATT_Y': begin
     filehead = 'eis_hk2'
     bintable = 1
     read_all_files = 1
             end
  'SC_ATT_Z': begin
     filehead = 'eis_hk2'
     bintable = 1
     read_all_files = 1
             end
  'TR_MODE': begin
     filehead = 'eis_hk2'
     bintable = 1
     read_all_files = 0
             end
  'UFSAUSE': begin
     filehead = 'eis_hk2'
     bintable = 1
     read_all_files = 0
             end
  'UFSBUSE': begin
     filehead = 'eis_hk2'
     bintable = 1
     read_all_files = 0
             end
  'CCDA_TEMP': begin
     filehead = 'eis_sts1'
     bintable = 3
     read_all_files = 1
             end
  'CCDB_TEMP': begin
     filehead = 'eis_sts1'
     bintable = 3
     read_all_files = 1
             end
  'MHC_REF_THER_0': begin
     filehead = 'eis_sts3'
     bintable = 1
     read_all_files = 1
             end
  'MHC_CAL_THER_0': begin
     filehead = 'eis_sts3'
     bintable = 1
     read_all_files = 1
             end
  'MHC_HZ_T10': begin
     filehead = 'eis_sts3'
     bintable = 5
     read_all_files = 1
             end
  'MHC_HZ_T15': begin
     filehead = 'eis_sts3'
     bintable = 5
     read_all_files = 1
             end
  'MDP_DSC_V_SAT': begin
     filehead = 'eis_sot'
     bintable = 1
     read_all_files = 1
             end
  'MDP_DSC_V_SUN': begin
     filehead = 'eis_sot'
     bintable = 1
     read_all_files = 1
             end
  'MDP_DSC_V_ETH': begin
     filehead = 'eis_sot'
     bintable = 1
     read_all_files = 1
             end
  else: begin
    message,'no such parameter!!'
        end
  endcase
  start_ut=self->getdate_obs_ut()
  date=start_ut
  end_ut=self->getdate_end_ut()
  date_obs=self->getdate_obs()
  date_end=self->getdate_end()

  done=0
  yesterday=0
  self.ioerror=0
  on_ioerror,ioerror
  repeat begin
    eis_find_directory,date,dir,head=self->getdir_head()
    f=file_search(dir+filehead+'*fits*')
    if f[0] eq '' then begin
      message,'no spacecraft data for '+date+' available for parameter '+parameter,/info
      self.ioerror=1
      return
    end
;    ti0=lonarr(n_elements(f))
;    ti1=lonarr(n_elements(f))
;; find start and end times for all files in the directory
;    for i=0,n_elements(f)-1 do begin
;      dum=readfits(f[i],hdr,/silent)
;      hex2dec,fxpar(hdr,'TI0'),dum,/quiet
;      ti0[i]=dum
;      hex2dec,fxpar(hdr,'TI1'),dum,/quiet
;      ti1[i]=dum
;    endfor

    ti0=ulonarr(n_elements(f))
    ti1=ulonarr(n_elements(f))
; find start and end times for all files in the directory
    for i=0,n_elements(f)-1 do begin
      dum=readfits(f[i],hdr,/silent)
      hex2dec,fxpar(hdr,'TI0'),dum,/quiet
      ti0[i]=ulong(dum)
      hex2dec,fxpar(hdr,'TI1'),dum,/quiet
      ti1[i]=ulong(dum)
  endfor

; Check if we are in the vicinity of the 23rd december 2010 rollover
; or later...
if fix(self->year(start_ut)) gt 2006 then begin
;    print,'Greater than 2006'
    if date_obs lt '002A3000'xul or date_obs gt 'FFF5CFFF'xul then begin
;        print,'We made it...'
        date_obs = long(date_obs)
        ti0 = long(ti0)
        ti1 = long(ti1)
    endif
endif
;print, 'year, ti0 min, max date_obs:', self->year(start_ut), min(ti0), max(ti0), date_obs

; construct list of files starting at date_obs...
; check if observation starts before first spcd file of observation date 
; ....if so set search directory to yesterday

;  print, 'date_obs', date_obs, ' ti0[0]', ti0[0], ' yesterday', yesterday

    if date_obs lt ti0[0] and not yesterday then begin
      mjd=date2mjd(self->year(start_ut),self->month(start_ut),self->day(start_ut))
      mjd2date,mjd-1,yr,mon,day
      date=anytim2cal(string(yr)+'-'+string(mon)+'-'+string(day)+'T00:00:00Z',form=11,/date)
      yesterday=1
      goto,newsearch
    endif
; ok, we should now be able to start looking at the right files
    istart=(max(where(ti0 le date_obs)))>0
    iend=max(where(ti0 le date_end))
; check if all files in directory start after date_end, if so then done....
    if iend eq -1 then begin
      done=1
      goto,newsearch
    endif

;    print,'iend', iend, ' istart', istart

    sub=indgen(iend-istart+1)+istart
    f=f[sub]
    ti1=ti1[sub]
    ti0=ti0[sub]
; ...read files up until date_end
    if read_all_files then begin
      for i=0,n_elements(f)-1 do begin
        pdata_0=reform(eis_read_fits_data(f[i],parameter,bintable))
        case n_elements(pdata) of
          0: pdata=reform(pdata_0)
          else: pdata=[pdata,pdata_0]
        endcase
      endfor
      if self->day(date) ne self->day(end_ut) and date_end gt max(ti1) then begin
        mjd=date2mjd(self->year(date),self->month(date),self->day(date))
        mjd2date,mjd+1,yr,mon,day
        date=anytim2cal(string(yr)+'-'+string(mon)+'-'+string(day)+'T00:00:00Z',form=11,/date)
      endif else done=1
      
    endif else begin

      pdata=(eis_read_fits_data(f[0],parameter,bintable))[0]
      
      done=1
    endelse
newsearch:
    yesterday=1
  endrep until done
  case parameter of 
  'SAT_ROT': begin
     self.sat_rot = ptr_new(pdata*2.14577e-5) ; conversion factor is 180/2^23
     self.crota1 = ptr_new(*self.sat_rot+self.inst_rot)
     self.crota2 = ptr_new(*self.sat_rot+self.inst_rot)
             end
  'TIME': begin
     case filehead of
     'eis_aocs1': self.time_aocs1 = ptr_new(pdata)
     'eis_hk2'  : self.time_hk2 = ptr_new(pdata)
     'eis_sts1' : self.time_sts1 = ptr_new(pdata)
     'eis_sts3' : self.time_sts3 = ptr_new(pdata)
     'eis_sot'  : self.time_sot = ptr_new(pdata)
     endcase
             end
  'UFSAXANG': begin
     self.ufsaxang = ptr_new(pdata)
             end
  'UFSAYANG': begin
     self.ufsayang = ptr_new(pdata)
             end
  'UFSBXANG': begin
     self.ufsbxang = ptr_new(pdata)
             end
  'UFSBYANG': begin
     self.ufsbyang = ptr_new(pdata)
             end
  'ERRANGZ': begin
     self.errangz = ptr_new(pdata)
             end
  'SC_ATT_X': begin
     self.att_x = ptr_new(pdata)
             end
  'SC_ATT_Y': begin
     self.att_y = ptr_new(pdata)
             end
  'SC_ATT_Z': begin
     self.att_z = ptr_new(pdata)
             end
  'TR_MODE': begin
     if n_elements(pdata) eq 0 then pdata=-1
     case pdata of
     0: self.tr_mode='FIX'
     1: self.tr_mode='TR1'
     2: self.tr_mode='TR2'
     3: self.tr_mode='TR3'
     4: self.tr_mode='TR4'
     else: self.tr_mode='UNKNOWN'
     endcase
             end
  'UFSAUSE': begin
     self.ufsause = pdata
             end
  'UFSBUSE': begin
     self.ufsbuse = pdata
             end
  'CCDA_TEMP': begin
     self.ccda_temp = ptr_new(pdata)
             end
  'CCDB_TEMP': begin
     self.ccdb_temp = ptr_new(pdata)
             end
  'MHC_REF_THER_0': begin
     self.mhc_ref_ther_0 = ptr_new(pdata)
             end
  'MHC_CAL_THER_0': begin
     self.mhc_cal_ther_0 = ptr_new(pdata)
             end
  'MHC_HZ_T10': begin
     self.mhc_hz_t10 = ptr_new(pdata)
             end
  'MHC_HZ_T15': begin
     self.mhc_hz_t15 = ptr_new(pdata)
             end
  'MDP_DSC_V_SAT': begin
     self.v_sat = ptr_new(pdata)
             end
  'MDP_DSC_V_SUN': begin
     self.v_sun = ptr_new(pdata)
             end
  'MDP_DSC_V_ETH': begin
     self.v_eth = ptr_new(pdata)
             end
  endcase
  return  
  ioerror: message,'IO error while searching for/reading parameter '+parameter,/info
           self.ioerror=1
  return
end
