pro eis_spcd::setxyoffset,init=init
  if n_elements(init) eq 1 then return
;
; EIS offset from z-axis of ultra fine sun sensor (UFSS) also called the ut offsets
; in the Shimojo FITS Keywords list "The List of Solar-B "Hinode" Mission-Wide FITS
; Keywords" 2006/11/14 ver. 1.1
; The following numbers are taken from "Alignment among Hinode Science Instruments
; (preliminary)" 2006/11/07 Hirohisa Hara 
; The middle of the eis field of view (cmir=892, fmir=1800) is 
; 13 XRT pixels South and 87 XRT pixels East of the AOCS (SOT) FOV 
; XRT pixel size is 1.025 arcsec
;
; The su offsets correspond to the inst_rot keyword and are the offsets between the
; origin of the UFSS coordinate and the Sun center
; 
  cal=obj_new('eis_cal',/quiet)
  self.xoffut = cal->getxoffsetut()
  self.yoffut = cal->getyoffsetut()
  self.xoffsu = cal->getxoffsetsu() ; so far undefined
  self.yoffsu = cal->getyoffsetsu() ; so far undefined
  obj_destroy,cal
  return
end
