;+
; NAME:
;       EIS_SYNSPEC__DEFINE defines the class EIS_SYNSPEC. Objects of this
;       class form the interface between the "Chianti" package and the EIS QL 
;       software. The EIS_SYTSNPEC class inherits the superclass HW_DATA
;
; PURPOSE:
;
; CATEGORY:
;       Hansteen/Wikstol Data analysis SW
;
; CALLING SEQUENCE: EIS_SYNSPEC is created by
;                   eis_synspec = obj_new('eis_synspec',det,region)
;
; INPUTS:
;       det: detector that synthetic spectra is to be computed for
;       region: the type of region synthetic spectra is to be computed for
;               i.e. 'qs','ar','fl',...
;
; KEYWORD PARAMETERS:
;
; OUTPUTS:
;
; CALLS:
;
; METHODS:
;       seteisdefaults,title=title: set defaultvalues for directories, fwhm and so on...
;       eisgenerate,det,region,title=title: generate spectrum for det and region
;       eisload,det,region: loads precomputed spectrum for det and region
;       getphotons,lambda,photons,dn,id=id,phot_peak=phot_peak,dn_peak=dn_peak: computes photon
;                         count and data number for spectrum loaded
;
;
; PROCEDURE:
;
; RESTRICTIONS:
;
; MODIFICATION HISTORY:
;       06-Jan-2006: Viggo H. Hansteen First version
;       10-Feb-2007: Viggo Hansteen  - Added help methods.
;        4-Jul-2008: A. Gardini      - Added HELP and INIT_EIS_SYNSPEC_METHODS.
;       
;       $Id: eis_synspec__define.pro 405 2010-07-04 11:21:38Z viggoh $
;-

pro eis_synspec__define
  struct={eis_synspec, $
          help:obj_new(), $
          eisdb_path:'',$
          synthspec_name:'spec_qs_a.genx',$
          detector: ' ', $
          inherits hw_synspec}
end
